import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
/**
 * 文件预览组件(可以拖动)
 */
import React, { useState } from 'react';
import PdfView from './pdf_view';
import ZoomImage from './zoom_image';
import DragbleModal from './dragble_modal';
import '../../../style/super_file_preview.less';
import PropTypes from 'prop-types';
var SuperFilePreview = function SuperFilePreview(props) {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    modal = _useState2[0],
    setModal = _useState2[1];
  var handleCloseModal = function handleCloseModal() {
    setModal(false);
  };
  var renderImage = function renderImage() {
    var isZoom = props.isZoom,
      children = props.children,
      path = props.path;
    return /*#__PURE__*/React.createElement("div", {
      className: "app-file-preview"
    }, /*#__PURE__*/React.createElement("div", {
      onClick: function onClick(e) {
        e.preventDefault();
        setModal(true);
      }
    }, children), modal ? isZoom ? /*#__PURE__*/React.createElement(ZoomImage, {
      path: path,
      onCancel: handleCloseModal
    }) : /*#__PURE__*/React.createElement(DragbleModal, {
      title: "\u56FE\u7247\u9884\u89C8",
      onCancel: handleCloseModal
    }, /*#__PURE__*/React.createElement("div", {
      className: "app-file-preview-image"
    }, /*#__PURE__*/React.createElement("a", {
      href: path,
      target: "_blank",
      rel: "noopener noreferrer"
    }, /*#__PURE__*/React.createElement("img", {
      src: path
    })))) : null);
  };
  var path = props.path,
    children = props.children,
    pdfHeight = props.pdfHeight;
  var match = path && path.match(/\.(pdf|jpg|jpeg|png|gif)/i);
  var suffix = match ? match[1] : '';
  switch (suffix) {
    case 'pdf':
      return /*#__PURE__*/React.createElement(PdfView, {
        path: path,
        pdfHeight: pdfHeight
      }, children);
    case 'jpg':
    case 'jpeg':
    case 'png':
    case 'gif':
      return renderImage();
    default:
      return /*#__PURE__*/React.createElement("div", {
        className: "app-file-preview"
      }, children);
  }
};
SuperFilePreview.propTypes = {
  path: PropTypes.string,
  children: PropTypes.any,
  isZoom: PropTypes.bool,
  pdfHeight: PropTypes.string
};
export default SuperFilePreview;