"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.URLS = void 0;
exports.fetch = axiosPost;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _axios = _interopRequireDefault(require("axios"));
var _tool = require("./tool");
var _status_code = _interopRequireDefault(require("./status_code"));
/**
 * api
 */
// import fetch from 'isomorphic-fetch'

var URLS = {
  'chance-type': '/chance-type',
  'user-list': '/user-list',
  'tree-list': '/tree-list',
  'rms/resource/getDownloadParam': '/rms/resource/getDownloadParam',
  'common-organize-list': '/common-organize-list',
  'common-manager-list': '/common-manager-list',
  'chance-type-group-list': '/chance-type-group-list',
  'chance-type-list': '/chance-type-list',
  'search-input-list': '/search-input-list',
  'get-tip-popover-list': '/get-tip-popover-list'
};
exports.URLS = URLS;
var customHeader = {
  Accept: 'application/json',
  'X-Requested-With': 'XMLHttpRequest',
  'Content-Type': 'application/json;charset=UTF-8'
};
var MthodEnum = {
  get: 'GET',
  delete: 'DELETE',
  head: 'HEAD',
  options: 'OPTIONS',
  post: 'POST',
  put: 'PUT',
  patch: 'PATCH',
  purge: 'PURGE',
  link: 'LINK',
  unlink: 'UNLINK'
};

/**
 * axios请求
 * @param  {String} path   请求路径
 * @param  {Object} data   请求参数
 * @param  {String} method 请求类型
 * @param  {Object} opts   请求选项
 * @return {Object}        Promise对象
 */
function axiosPost(apiPath, apiData, apiMethod, opts) {
  var path = apiPath;
  if (!path) return Promise.reject(new Error('无效的API地址'));
  var option = {
    method: null,
    credentials: 'include',
    headers: customHeader,
    params: {}
  };
  var method = MthodEnum[apiMethod ? apiMethod.toLowerCase() : 'get'];
  option.method = method;
  if (!(0, _tool.isObjEmpty)(apiData)) {
    option.params = apiData;
  }
  return (0, _axios.default)(path, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, option), opts)).then(function (res) {
    var data = res.data;
    if (res.status !== _status_code.default.SUCCESS) {
      return Promise.reject(new Error(data.msg));
    }
    return Promise.resolve(data);
  });
}