"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _antd = require("antd");
var _ahooks = require("ahooks");
var _tool = require("../../../common/tool");
var _rule = _interopRequireDefault(require("../../../enums/rule"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * 省市区级联组件
 */

// 封装组件
var AddressSelect = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _useSetState = (0, _ahooks.useSetState)({
      options: [],
      level: props.level || 3,
      selectValue: props.value.slice(0, 3),
      initValue: props.value.slice(3)
    }),
    _useSetState2 = (0, _slicedToArray2.default)(_useSetState, 2),
    state = _useSetState2[0],
    setState = _useSetState2[1];
  (0, _react.useEffect)(function () {
    var level = state.level;
    var data = (0, _tool.getCityTreeData)(level);
    setState({
      options: data
    });
  }, []);
  var selectChange = function selectChange(data) {
    var onChange = props.onChange;
    var initValue = state.initValue;
    setState({
      selectValue: data
    });
    onChange(data.concat(initValue));
  };
  var inputChange = function inputChange(event) {
    var onChange = props.onChange;
    var selectValue = state.selectValue;
    var inputValue = event.target.value;
    var data = inputValue ? [inputValue] : [];
    setState({
      initValue: data
    });
    onChange(selectValue.concat(data));
  };
  var options = state.options,
    level = state.level,
    initValue = state.initValue,
    selectValue = state.selectValue;
  var input = initValue.join();
  var inputLength = input.length;
  var disabled = props.disabled;
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: ref
  }, level === 4 ? /*#__PURE__*/_react.default.createElement(_antd.Row, {
    gutter: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: selectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    disabled: disabled,
    defaultValue: input,
    maxLength: _rule.default.addressLength,
    onChange: inputChange,
    suffix: "".concat(inputLength, "/").concat(_rule.default.addressLength)
  }))) : /*#__PURE__*/_react.default.createElement(_antd.Cascader, {
    disabled: disabled,
    defaultValue: selectValue,
    options: options,
    onChange: selectChange,
    placeholder: "\u8BF7\u9009\u62E9"
  }));
});
AddressSelect.propTypes = {
  level: _propTypes.default.number,
  value: _propTypes.default.array,
  disabled: _propTypes.default.bool,
  onChange: _propTypes.default.func
};
var _default = AddressSelect;
exports.default = _default;