"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _antd = require("antd");
var _api = require("../../../common/api");
var _tool = require("../../../common/tool");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/* eslint-disable consistent-return */
/* eslint-disable func-names */
/**
 * 异步选择组件
 */

var Option = _antd.Select.Option;

// 封装组件
var AjaxSelect = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = (0, _react.useState)([]),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    listData = _useState4[0],
    setListData = _useState4[1];
  (0, _react.useEffect)(function () {
    handleGetList();
  }, []);
  var handleGetList = function handleGetList() {
    var apiPath = props.apiPath,
      apiData = props.apiData,
      apiMethod = props.apiMethod,
      listName = props.listName;
    setLoading(true);
    (0, _api.fetch)(apiPath, apiData, apiMethod).then(function (data) {
      setLoading(false);
      setListData(data.data);
    }).catch(function (err) {
      _tool.log.error(err);
      _antd.message.error("\u83B7\u53D6".concat(listName, "\u5931\u8D25:").concat(err.message));
    });
  };
  var handleChange = function handleChange(key) {
    var value = props.value,
      listValueKey = props.listValueKey,
      listNameKey = props.listNameKey,
      onChange = props.onChange;
    if (Array.isArray(value)) {
      if (!key) return onChange(['', '']);
      var label;
      listData.some(function (item) {
        if (item[listValueKey].toString() === key) {
          label = item[listNameKey];
          return true;
        }
        return false;
      });
      onChange([key, label]);
    } else {
      onChange(key || '');
    }
  };
  var value = props.value,
    listName = props.listName,
    listValueKey = props.listValueKey,
    listNameKey = props.listNameKey,
    disabled = props.disabled;
  var selectValue;
  if (Array.isArray(value)) {
    // eslint-disable-next-line prefer-destructuring
    selectValue = value[0];
  } else {
    selectValue = value;
  }
  return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: loading,
    className: "app-ajax-select"
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    showSearch: true,
    optionFilterProp: "children",
    value: selectValue,
    onChange: handleChange,
    placeholder: "\u9009\u62E9".concat(listName),
    notFoundContent: "\u672A\u627E\u5230".concat(listName),
    allowClear: true,
    disabled: disabled,
    ref: ref
  }, /*#__PURE__*/_react.default.createElement(Option, {
    value: "",
    title: "\u9009\u62E9".concat(listName)
  }, "\u9009\u62E9", listName), listData.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: index,
      value: item[listValueKey].toString(),
      title: item[listNameKey]
    }, item[listNameKey]);
  })));
});
AjaxSelect.propTypes = {
  apiPath: _propTypes.default.string.isRequired,
  // api接口,由于直接诶读取data.data的数组数据,所以该API不能使用分页
  apiData: _propTypes.default.object,
  // api请求附加的数据
  apiMethod: _propTypes.default.string,
  // api请求method
  listName: _propTypes.default.string.isRequired,
  // 缺省列表名称
  listValueKey: _propTypes.default.string.isRequired,
  // 列表值的key值
  listNameKey: _propTypes.default.string.isRequired,
  // 列表名称key值
  value: _propTypes.default.oneOfType([
  // 值,支持字符串和数组形式
  _propTypes.default.string,
  // key值
  _propTypes.default.array // [key, label]形式
  ]),

  onChange: _propTypes.default.func,
  // 获取值变化函数
  disabled: _propTypes.default.bool
};
var _default = AjaxSelect;
exports.default = _default;