"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _antd = require("antd");
var _tool = require("../../../common/tool");
var _propTypes = _interopRequireDefault(require("prop-types"));
/**
 * 数字范围输入框
 */

var InputRangeNumber = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var inputRangeNumberRef = _react.default.useRef();
  inputRangeNumberRef = ref;
  var handleChangeMin = function handleChangeMin(data) {
    var value = props.value,
      onChange = props.onChange;
    if (value.length > 0 && data < value[0]) {
      _antd.message.error('当前值不能大于最大值');
      return;
    }
    onChange([data, value[1]]);
  };
  var handleChangeMax = function handleChangeMax(data) {
    var value = props.value,
      onChange = props.onChange;
    if (value.length > 0 && data < value[0]) {
      _antd.message.error('当前值不能小于最小值');
      return;
    }
    onChange([value[0], data]);
  };
  var value = props.value,
    disabled = props.disabled;
  return /*#__PURE__*/_react.default.createElement(_antd.Row, {
    ref: inputRangeNumberRef,
    gutter: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.InputNumber, {
    onChange: (0, _tool.debounce)(handleChangeMin, 500),
    value: value[0],
    disabled: disabled,
    style: {
      width: '100%'
    },
    placeholder: "\u8BF7\u8F93\u5165\u6700\u5C0F\u503C"
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_antd.InputNumber, {
    onChange: (0, _tool.debounce)(handleChangeMax, 500),
    value: value[1],
    disabled: disabled,
    style: {
      width: '100%'
    },
    placeholder: "\u8BF7\u8F93\u5165\u6700\u5927\u503C"
  })));
});
InputRangeNumber.propTypes = {
  value: _propTypes.default.number,
  onChange: _propTypes.default.func,
  disabled: _propTypes.default.bool
};
var _default = InputRangeNumber;
exports.default = _default;