"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _antd = require("antd");
var _api = require("../../../common/api");
var _tool = require("../../../common/tool");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
/**
 * 通用表格
 */

var CommonTable = function CommonTable(props) {
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = (0, _react.useState)({}),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    tableData = _useState4[0],
    setTableData = _useState4[1];
  (0, _react.useEffect)(function () {
    handleGetData({
      page: 1,
      pageSize: 10
    });
  }, []);
  var handleGetData = function handleGetData(data) {
    var apiPath = props.apiPath,
      apiData = props.apiData,
      apiMethod = props.apiMethod;
    setLoading(true);
    var sendData = (0, _tool.filterEmptyData)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, apiData), data));
    (0, _api.fetch)(apiPath, sendData, apiMethod).then(function (res) {
      // 判断如果卸载,则不再设置数据
      if (!res.data || !res.data.content) res.data.content = [];
      res.data.content.map(function (item, inx) {
        item.key = inx;
      });
      setLoading(false);
      setTableData(res.data);
    }).catch(function (err) {
      setLoading(false);
      _antd.message.error("\u83B7\u53D6\u6570\u636E\u5931\u8D25:".concat(err.message));
    });
  };
  var handleChangePage = function handleChangePage(page, filters, sorter) {
    var sortType = props.sortType;
    var orders = {};
    if (!(0, _tool.isObjEmpty)(sorter)) {
      sortType.map(function (item) {
        if (item.text === sorter.columnKey) {
          orders = {
            sortType: item.value,
            isDesc: sorter.order === 'descend' ? 1 : 0
          };
        }
      });
    }
    handleGetData((0, _objectSpread2.default)({
      page: page.current,
      pageSize: page.pageSize
    }, orders));
  };
  var tableTitle = props.tableTitle,
    columns = props.columns,
    isShowPagination = props.isShowPagination,
    isShowBordered = props.isShowBordered,
    rightLink = props.rightLink,
    rightLinkTitle = props.rightLinkTitle,
    pageSizeOptions = props.pageSizeOptions,
    rowKeyFun = props.rowKeyFun,
    scroll = props.scroll;
  var pageData;
  if (isShowPagination && pageSizeOptions) {
    pageData = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, (0, _tool.getPageData)(tableData)), {}, {
      pageSizeOptions: pageSizeOptions
    });
  } else pageData = (0, _objectSpread2.default)({}, (0, _tool.getPageData)(tableData));
  return /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    spinning: loading
  }, tableTitle ? /*#__PURE__*/_react.default.createElement("h3", null, tableTitle, rightLink ? /*#__PURE__*/_react.default.createElement("a", {
    className: "right-link pull-right",
    href: rightLink,
    target: "_blank",
    rel: "noopener noreferrer"
  }, rightLinkTitle) : null) : null, /*#__PURE__*/_react.default.createElement(_antd.Table, {
    columns: columns,
    bordered: isShowBordered,
    pagination: isShowPagination ? pageData : false,
    dataSource: tableData.content || [],
    onChange: handleChangePage,
    rowKey: rowKeyFun,
    scroll: scroll
  }));
};
CommonTable.propTypes = {
  rightLink: _propTypes.default.string,
  // table 右侧链接
  rightLinkTitle: _propTypes.default.string,
  // table 右侧链接文案
  tableTitle: _propTypes.default.string,
  // table名字
  columns: _propTypes.default.array.isRequired,
  // 表格的配置项
  isShowBordered: _propTypes.default.bool,
  // table是否带有边框,
  isShowPagination: _propTypes.default.bool,
  // table是否展示分页
  apiPath: _propTypes.default.string.isRequired,
  // api接口,由于直接诶读取data.data的数组数据,所以该API不能使用分页
  apiData: _propTypes.default.object,
  // api请求附加的数据
  apiMethod: _propTypes.default.string,
  // api请求method,
  sortType: _propTypes.default.array,
  // table排序类型 [{ text: 'sortName', value: 'sortValue'}],
  pageSizeOptions: _propTypes.default.array,
  rowKeyFun: _propTypes.default.func,
  scroll: _propTypes.default.object
};
CommonTable.defaultProps = {
  isShowBordered: true
};
var _default = CommonTable;
exports.default = _default;