"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _file_preview = _interopRequireDefault(require("./file_preview"));
var _dragble_modal = _interopRequireDefault(require("./dragble_modal"));
var _zoom_image = _interopRequireDefault(require("./zoom_image"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// pdf预览组件

function handlePdfPath(rmsPath) {
  var curOrigin = window.location.origin;
  var filePath = "".concat(curOrigin, "/file/?path=").concat(encodeURIComponent(rmsPath));
  return "".concat(curOrigin, "/viewer.html?file=").concat(encodeURIComponent(filePath));
}
var PdfView = function PdfView(props) {
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    showModal = _useState2[0],
    setShowModal = _useState2[1];
  var renderImage = function renderImage() {
    var isZoom = props.isZoom,
      children = props.children,
      path = props.path;
    if (isZoom) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "app-file-preview"
      }, /*#__PURE__*/_react.default.createElement("div", {
        onClick: function onClick(e) {
          e.preventDefault();
          setShowModal(true);
        }
      }, children), showModal ? /*#__PURE__*/_react.default.createElement(_zoom_image.default, {
        path: path,
        onCancel: handleCloseModal
      }) : null);
    }
    return /*#__PURE__*/_react.default.createElement(_file_preview.default, {
      path: path
    }, children);
  };
  var handleCloseModal = function handleCloseModal() {
    setShowModal(false);
  };
  var children = props.children,
    path = props.path,
    pdfHeight = props.pdfHeight;
  var isPdf = /.pdf/.test(path.toLowerCase());
  if (!isPdf) {
    return renderImage();
  }
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "app-file-preview"
  }, /*#__PURE__*/_react.default.createElement("div", {
    onClick: function onClick(e) {
      e.preventDefault();
      setShowModal(true);
    }
  }, children), showModal ? /*#__PURE__*/_react.default.createElement(_dragble_modal.default, {
    onCancel: handleCloseModal,
    title: "pdf\u9884\u89C8"
  }, /*#__PURE__*/_react.default.createElement("iframe", {
    frameBorder: "0",
    src: handlePdfPath(path),
    style: {
      width: '100%',
      height: pdfHeight || '500px'
    }
  })) : null);
};
PdfView.propTypes = {
  path: _propTypes.default.string,
  children: _propTypes.default.any,
  isZoom: _propTypes.default.bool,
  pdfHeight: _propTypes.default.string
};
var _default = PdfView;
exports.default = _default;