"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _react = _interopRequireDefault(require("react"));
var _ajax_select = _interopRequireDefault(require("../../basic/form_item/ajax_select"));
var _dynamic_ajax_select = _interopRequireDefault(require("../../basic/form_item/dynamic_ajax_select"));
var _antd = require("antd");
/**
 * 通过业务线获取对应的机会类型
 */

var ChanceTypeSelect = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var handleChanceChange = function handleChanceChange(data) {
    var onChange = props.onChange,
      value = props.value;
    onChange((0, _objectSpread2.default)((0, _objectSpread2.default)({}, value), {}, {
      chanceGroupId: data,
      chanceTypeId: '',
      type: 'chanceGroup'
    }));
  };
  var handleChanceTypeChange = function handleChanceTypeChange(data) {
    var onChange = props.onChange,
      value = props.value;
    var result = {
      chanceType: data.chanceType,
      chanceGroupId: null,
      type: 'chanceType'
    };
    if (data.groupId) result.chanceGroupId = data.groupId;
    if (data) onChange((0, _objectSpread2.default)((0, _objectSpread2.default)({}, value), result));
  };
  var value = props.value,
    chanceTypeGroupApiPath = props.chanceTypeGroupApiPath,
    chanceTypeApiPath = props.chanceTypeApiPath,
    firstShowAll = props.firstShowAll,
    disabled = props.disabled;
  return /*#__PURE__*/_react.default.createElement(_antd.Row, {
    gutter: 8,
    ref: ref,
    className: "app-chance-type-select"
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_ajax_select.default, {
    apiPath: chanceTypeGroupApiPath,
    apiMethod: "GET",
    listName: "\u4E1A\u52A1\u7EBF",
    listValueKey: "groupId",
    listNameKey: "groupName",
    onChange: handleChanceChange,
    value: value.chanceGroupId ? value.chanceGroupId : '',
    disabled: disabled
  })), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 12
  }, /*#__PURE__*/_react.default.createElement(_dynamic_ajax_select.default, {
    apiPath: chanceTypeApiPath,
    apiMethod: "GET",
    apiData: value.chanceGroupId ? {
      chanceGroupId: value.chanceGroupId
    } : {},
    listName: "\u673A\u4F1A\u7C7B\u578B",
    listValueKey: "chanceType",
    listNameKey: "chanceTypeName",
    onChange: handleChanceTypeChange,
    value: value.chanceType || '',
    firstShowAll: firstShowAll,
    disabled: disabled
  })));
});
var _default = ChanceTypeSelect;
exports.default = _default;